theory Insertion_Sort
imports Main
begin

fun insert :: "'a::linorder \<Rightarrow> 'a list \<Rightarrow> 'a list"
where
  "insert x [] = [x]"
| "insert x (y#ys) = (if x \<le> y then x#y#ys else y # insert x ys)"

abbreviation "isort xs \<equiv> fold insert xs []"

lemma set_insert [simp]:
  "set (insert x xs) = {x} \<union> set xs"
by (induct xs) auto

lemma sorted_insert [simp]: "sorted (insert x xs) \<longleftrightarrow> sorted xs"
by (induct xs) (auto simp: sorted_Cons)

lemma sorted_fold_insert [simp]:
  "\<forall>ys. sorted ys \<longrightarrow> sorted (fold insert xs ys)"
by (induct xs) auto

lemma sorted_isort: "sorted (isort xs)" by simp

fun count :: "'a \<Rightarrow> 'a list \<Rightarrow> nat"
where
  "count x [] = 0"
| "count x (y#ys) = (if x = y then count x ys + 1 else count x ys)"

lemma count_insert [simp]:
  "count x (insert y ys) = (if x = y then count x ys + 1 else count x ys)"
by (induct ys) auto

lemma count_fold_insert [simp]:
  "\<forall>ys. count x (fold insert xs ys) = count x xs + count x ys"
by (induct xs) auto

lemma count_isort: "count x (isort xs) = count x xs" by simp

end
