theory Insertion_Sort_Live
imports Main
begin

declare [[names_short]]

fun insert :: "'a::linorder \<Rightarrow> 'a list \<Rightarrow> 'a list"
where
  "insert x [] = [x]"
| "insert x (y#ys) = (if x \<le> y then x#y#ys else y # insert x ys)"

thm insert.simps

value "insert (1::nat) [0,2]"

term fold

abbreviation
"isort xs \<equiv> fold insert xs []"

term sorted
thm sorted.Nil
thm sorted_Cons
thm sorted_append

lemma [simp]:
  "set (insert x xs) = set xs \<union> {x}"
apply (induct xs)
apply auto
done

lemma [simp]:
  "sorted (insert x xs) = sorted xs"
apply (induct xs)
apply (auto simp: sorted_Cons)
done

lemma [simp]:
  "\<forall>ys. sorted ys \<longrightarrow> sorted (fold insert xs ys)"
apply (induct xs)
apply auto
done

lemma "sorted (isort xs)"
by auto

abbreviation "wrong_sort xs \<equiv> []"

end